﻿/**

*/
module etc.negui.draw.draw;

debug import std.stdio: wl = writefln;
debug(draw) void main() {}

import etc.negui.system.base;

///
class DrawException: NeGuiException {
	mixin MixInNeGuiException;
}


///
template GetImportObject(alias Graphic, alias Handle, alias Struct, alias CreateStructFunc) {
	const ref Struct GetStruct(HANDLE Handle, string file=__FILE__, int line=__LINE__) {
		auto StructPonit=new Struct;
		if(GetObject(Handle, Struct.sizeof, StructPonit) == 0) {
			throw new DrawException(Text(Graphic),
				new DrawException(Text("情報取得失敗"), null, file, line)
			);
		}
		return *StructPonit;
	}
	bool Import(ref const(Struct) StructPonit) {
		Kill();
		scope(exit) if(Handle) Suicide = true;
		return (Handle = CreateStructFunc(cast(Struct*)&StructPonit)) != null ? true: false;
	}
}

/***/
abstract class Draw: HandleRaii {
	mixin HandleRaiiClass;
	mixin MixInHandleRaiiNotDuplicate;
}

