﻿/**
まがいもの。

Note:
	未完成。
	入力待ちがわからん。
*/
module etc.negui.process.shell;
deprecated:
debug import std.stdio: wl = writefln;
debug(shell) void main() {}

import std.contracts;
import core.thread;

import win32.windows;

import etc.negui.system.base;
import etc.negui.environ.security;
import etc.negui.negui;
import etc.negui.process.pipe;
import etc.negui.process.process;


///
class ShellExecException: ExecuteException {
	mixin MixInNeGuiException;
}

///
alias void delegate(in ubyte[]) ReaderClosure;

/***/
class ShellExec: Thread, IRaii {
	///
	override protected void Kill() {
		delete Shell;
		delete OutputPipe;
		delete ErrorPipe;
	}
	///
	~this() {
		Kill;
	}
	private {
		version(none) {
			Pipe InputPipe;
		}
		Pipe OutputPipe;
		Pipe ErrorPipe;

		Process Shell;
		
		Text Command;
		Text WorkFolder;
		DWORD ReturnCode;

		struct READER {
			ReaderClosure dg;
			ubyte[] data;
			Appender!(typeof(data)) app;

			void initialize() {
				app = Appender!(typeof(data))(&data);
			}
		}

		READER NormalReader;
		READER ErrorReader;
	}
	/// 標準出力のデータ。
	const const(ubyte[]) normalReadData() {
		return NormalReader.data;
	}
	/// エラーデータ。
	const const(ubyte[]) errorReadData() {
		return ErrorReader.data;
	}

	/**
	Params:
		Command =実行コマンド。

		WorkFolder =作業フォルダ。

		NormalReadDg = 標準出力読み込み時に実行するデリゲート。
	
		ErrorReadDg = エラー出力読み込み時に実行するデリゲート。

		ShowShell = 表示方法。

		Buffer = バッファサイズ。
	*/
	this(
		in Text Command, in Text WorkFolder=Text.init,
		ReaderClosure NormalReadDg=null,
		ReaderClosure ErrorReadDg=null,
		SHOW ShowShell=SHOW.HIDE,
		size_t Buffer=0
	) {
		this.Command    = Command.dup;
		this.WorkFolder = WorkFolder.dup;

		SECURITY Security;
		with(Security) {
			initialize();
			inheritance = true;
		}
		
		OutputPipe = new Pipe(Security, Buffer);
		
		version(none) {
			InputPipe  = new Pipe(Security, 8000);

			auto TempWriter=InputPipe.writer;
			InputPipe.writer=TempWriter.dup;
			delete TempWriter;
		}

		
		ErrorPipe  = new Pipe(Security, Buffer);

		NormalReader.initialize();
		ErrorReader.initialize();
		NormalReader.dg = NormalReadDg;
		ErrorReader.dg = ErrorReadDg;
		
		
		STARTUPINFORMATION StartupInfo;
		with(StartupInfo) {
			initialize();
			flags = FLAG.USESTDHANDLES;
			show  = ShowShell;
			version(none) {
				stdInput  = InputPipe.reader();
			}
			stdOutput = OutputPipe.writer();
			stdError  = ErrorPipe.writer();
		}
		Shell = new Process(
			Text.init, Command, WorkFolder,
			&Security, null,
			true,
			Process.PRIORITY.NONE, Process.CREATE.DETACHED_PROCESS,
			null,
			StartupInfo
		);
		
		super(&run);
	}

	///
	size_t waitTime=10;

	///
	void run() {
		WaitForInputIdle(Shell.info.hProcess, INFINITE);

		DWORD Result;
		
		do {
			Result = WaitForSingleObject(Shell.info.hProcess, waitTime);
			
			HRESULT Event;
			
			Event = WaitForSingleObject(OutputPipe.reader(), waitTime);
			if(Event==WAIT_OBJECT_0) {
				if(auto NormalRead=OutputPipe.read) {
					NormalReader.app.put(NormalRead);
					if(NormalReader.dg) {
						NormalReader.dg(NormalRead);
					}
				}
			}
			
			Event = WaitForSingleObject(ErrorPipe.reader(), waitTime);
			if(Event==WAIT_OBJECT_0) {
				if(auto ErrorRead=ErrorPipe.read) {
					ErrorReader.app.put(ErrorRead);
					if(ErrorReader.dg) {
						ErrorReader.dg(ErrorRead);
					}
				}
			}

			MSG Message=void;
			if(PeekMessage(&Message, null, 0, 0, PM_REMOVE)) {
				TranslateMessage(&Message);
				DispatchMessage(&Message);
			}
			if(Result == WAIT_OBJECT_0) {
				break;
			}
		} while(Result != WAIT_ABANDONED);
		
		ReturnCode = Shell.exitCode;
	}
}
debug(shell) unittest {
			scope s=new ShellExec(Text(`ping localhost`), Text.init,(in ubyte[] data){wl("%s", cast(string)data);});
	s.start;

	s.join;
		wl("%s",cast(string)s.normalReadData);
		wl("%s",cast(string)s.errorReadData);
}




