﻿/**
リッチエディット。
*/
module etc.negui.control.editbox.richedit;

debug import std.stdio: wl = writefln;

debug(richedit) void main() {}

import win32.windows;
import win32.richedit;

import etc.negui.system.base;
//import etc.negui.system.type.base;
import etc.negui.system.type.basic;
import etc.negui.system.type.enumerated;
import etc.negui.system.type.record;

//import etc.negui.window.window;
public import etc.negui.negui;
public import etc.negui.control.control;
public import etc.negui.control.editbox.editbox;
import etc.negui.file.dll;


/**
*/
class RichEdit: MultiEdit {
	
	private static DLL RichedDLL;
	static this() {
		RichedDLL = new DLL(Text("RICHED32.DLL"));
	}
	static ~this() {
		delete RichedDLL;
	}
	/**
	History:
		$(HIST_VER 1.032,
			$(HIST_P 処理内容変更。)
			$(HIST_S 引数追加。)
		)
	*/
	this(NeGui Owner, ITEM_ID Id, bool HorizonScroll=true) {
		NEGUIINFO NeGuiInfo;
		
		NeGuiInfo.owner     = Owner;
		NeGuiInfo.id        = Id;
		
		//this(&NeGuiInfo);
		this(NeGuiInfo, HorizonScroll);
	}
	/**
	Deprecated:
		廃止予定。
	*/
	deprecated override this(NEGUIINFO* NeGuiInfo, bool HorizonScroll) {
		/+
		NeGuiInfo.Style |= ES_AUTOHSCROLL | ES_NOHIDESEL;
		NeGuiInfo.ExStyle |= WS_EX_CLIENTEDGE;
		NeGuiInfo.ClassName = RICHEDIT_CLASS;
		
		super(NeGuiInfo,true);
		+/
		this(*NeGuiInfo, HorizonScroll);
	}
	/**
	History:
		$(HIST_VER 1.032,
			$(HIST_NEW)
		)
	*/
	override this(ref NEGUIINFO NeGuiInfo, bool HorizonScroll) {
		NeGuiInfo.style     |= ES_AUTOHSCROLL | ES_NOHIDESEL;
		NeGuiInfo.exStyle   |= WS_EX_CLIENTEDGE;
		NeGuiInfo.className  = Text(RICHEDIT_CLASS);
		
		super(NeGuiInfo, HorizonScroll);
	}
}


